DOC_HEADER = 'Checks if an object has the attribute{}.'
DOC_BODY = ('\n\n'
            'Parameters\n'
            '----------\n'
            'value\n'
            '    The literal or variable to check the attribute(s) of.\n'
            'name : str, optional\n'
            '    Name of the variable to check the attributes(s) of.\n'
            '    Defaults to None.\n'
            '\n'
            'Returns\n'
            '-------\n'
            'value\n'
            '    The `value` passed in.\n'
            '\n'
            'Attributes\n'
            '----------\n'
            'attrs : tuple(str)\n'
            '    The attribute(s) to check for.\n'
            '\n'
            'Methods\n'
            '-------\n'
            'o(callable) : CompositionOf\n'
            '    Daisy-chains the attribute checker to another `callable`,\n'
            '    returning the functional composition of both.\n'
            '\n'
            'Raises\n'
            '------\n'
            'MissingAttrError\n'
            '    If the variable or literal does not have (one of) the\n'
            '    required attribute(s).\n'
            '\n'
            'See also\n'
            '--------\n'
            'Just, CompositionOf')
